#include "controlpoints.h"
#include <structs.h>
#include <math.h>
#include <algorithm>
#include <iostream>

controlpoints::controlpoints()
{
    if(object.type=="circle"){

        int segments = 8; //45 degrees rotation
        double radius = sqrt(pow(object.end.x-object.center.x,2)+pow(object.end.y-object.center.y,2));
        for (int j = 1; j<segments; j++){ //ccw direction
            double theta = 2.0 * M_PI * int(j) / int(segments);
            double x = radius * cosf(theta);
            double y = radius * sinf(theta);
            object.control.push_back({x+object.center.x,y+object.center.y,object.center.z});
            //std::cout<<"control x:"<<x+object.center.x<<" control y"<<y+object.center.y<<std::endl;
        }
        //morph circle into cw
        std::reverse(object.control.begin(),object.control.end());
        //print output
//        for(int i=0; i<object.control.size(); i++){
//            std::cout<<"reversed -- control x:"<<object.control.at(i).x<<"control y:"<<object.control.at(i).y<<std::endl;
//        }
    }

    if(object.type=="ellipse"){
        //center point to endpoint mayor axis, center point to inputpoint minor axis
        double radius_x = sqrt(pow(object.end.x-object.center.x,2) + pow(object.end.y-object.center.y,2));
        double radius_y = sqrt(pow(object.input.x-object.center.x,2) + pow(object.input.y-object.center.y,2));

        //calculate angle of ellipse
        double x1=object.end.x;
        double y1=object.end.y;
        double radian = atan2(y1 - object.center.y, x1 - object.center.x);
        double angle = radian * (180 / M_PI);
        if (angle < 0.0)
            angle += 360.0;

        for(double j = object.pi_angle_start+M_PI/4; j<object.pi_angle_end; j+=M_PI/4) //ccw direction
        {
            //non rotated ellipse..
            double non_rotated_x = /*center_x +*/ cos(j)*radius_x;
            double non_rotated_y = /*center_y +*/ sin(j)*radius_y;
            //glVertex2d(center_x + cos(j)*radius_x, center_y + sin(j)*radius_y);

            //rotated ellipse..
            double rotate_x = object.center.x  + cos(angle * M_PI / 180.0 )* non_rotated_x - sin(angle * M_PI / 180.0 ) * non_rotated_y;
            double rotate_y = object.center.y  + sin(angle * M_PI / 180.0 )* non_rotated_x + cos(angle * M_PI / 180.0 ) * non_rotated_y;
            object.control.push_back({rotate_x,rotate_y,0});
            //std::cout<<"control x:"<<rotate_x<<" control y"<<rotate_y<<std::endl;
        }

        //morph ellipse into cw by inversing the control points
        std::reverse(object.control.begin(),object.control.end());

        //print output
        //for(int i=0; i<object.control.size(); i++){
            //std::cout<<"reversed -- control x:"<<object.control.at(i).x<<"control y:"<<object.control.at(i).y<<std::endl;
        //}
    }
}
