#include <variable.h>
#include <structs.h>
#include <math.h>
#include <iostream>
#include <algorithm>
#include <controlpoints.h>

OBJECT object;
std::vector<OBJECT> objects;
POINT arc_center(POINT a, POINT b, POINT c);

void clear();
void input_data(){

    //input data
    if(mode=="line"){
        if(click==0){
            message = "click startpoint";
        }
        if(click==1){
            object.type="line";
            object.red=0; //todo : connect to gui
            object.green=1;
            object.blue=1;
            object.alpha=1;
            object.start.x=mx;
            object.start.y=my;
            object.start.z=mz;
            object.end.x=mx;
            object.end.y=my;
            object.end.z=mz;
            click=2;
        }
        if(click==2){ //preview
            object.end.x=mx;
            object.end.y=my;
            object.end.z=mz;
        }
        if(click==3){ //write data
            objects.push_back(object);
            clear();
        }
        if(int_key==16777216){//key escape, clean preview data
            clear();
        }
    }

    if(mode=="linestrip"){
        if(click==0){
            message = "click startpoint";
        }
        if(click==1){
            object.type="line";
            object.red=0; //todo : connect to gui
            object.green=1;
            object.blue=1;
            object.alpha=1;
            object.start.x=mx;
            object.start.y=my;
            object.start.z=mz;
            object.end.x=mx;
            object.end.y=my;
            object.end.z=mz;
            click=2;
        }
        if(click==2){ //preview
            object.end.x=mx;
            object.end.y=my;
            object.end.z=mz;
        }
        if(click==3){ //morph into linestrip
            object.type="linestrip";
            object.control.push_back({mx,my,mz});
            click=2;
        }
        if(int_key==16777216){//key escape, clean preview data
            clear();
        }
        if(int_key==16777220){//key enter
            object.end.x=object.control.back().x; //save including the last control point
            object.end.y=object.control.back().y;
            object.end.z=object.control.back().z;
            object.control.erase(object.control.end()-1);

            //print output
            //for(int i=0; i<object.control.size(); i++){
            //    std::cout<<"control x:"<<object.control.at(i).x<<" control y:"<<object.control.at(i).y<<std::endl;
            //}

            objects.push_back(object);
            clear();
        }
    }

    if(mode=="rectangular"){
        if(click==0){
            message = "click startpoint";
        }
        if(click==1){
            object.type="rectangular";
            object.red=0; //todo : connect to gui
            object.green=1;
            object.blue=1;
            object.alpha=1;
            object.start.x=mx; //lower left corner
            object.start.y=my;
            object.start.z=mz;
            object.control.push_back({mx,my,mz}); //upper left corner
            object.control.push_back({mx,my,mz}); //upper right corner
            object.control.push_back({mx,my,mz}); //lower right corner
            object.end.x=mx; //back to start
            object.end.y=my;
            object.end.z=mz;

            click=2;
        }
        if(click==2){ //preview
            //lower left is unchanged.
            object.control.at(0).y=my; //upper left corner
            object.control.at(1).x=mx; //upper right corner
            object.control.at(1).y=my;
            object.control.at(2).x=mx; //lower right corner
            object.end.x=object.start.x; //endpoint is equal to startpoint
            object.end.y=object.start.y;
            object.end.z=object.start.z;
        }
        if(click==3){ //write data

            //            print output
            //            std::cout<<"start x:"<<object.start.x<<" start y:"<<object.start.y<<std::endl;
            //            for(int i=0; i<object.control.size(); i++){
            //                std::cout<<"control x:"<<object.control.at(i).x<<" control y:"<<object.control.at(i).y<<std::endl;
            //            }
            //            std::cout<<"end x:"<<object.end.x<<" end y:"<<object.end.y<<std::endl;

            objects.push_back(object);
            clear();
        }
        if(int_key==16777216){//key escape, clean preview data
            clear();
        }
    }

    if(mode=="circle"){
        if(click==0){
            message = "click centerpoint";
        }
        if(click==1){
            object.type="circle";
            object.red=0; //todo : connect to gui
            object.green=1;
            object.blue=1;
            object.alpha=1;
            object.center.x=mx;
            object.center.y=my;
            object.center.z=mz;
            click=2;
        }
        if(click==2){ //preview
            object.start.x=mx; //dummy
            object.start.y=my;
            object.start.z=mz;
            object.end.x=mx;
            object.end.y=my;
            object.end.z=mz;
        }
        if(click==3){ //write data
            controlpoints();
            objects.push_back(object);
            clear();
        }
        if(int_key==16777216){//key escape, clean preview data
            clear();
        }
    }

    if(mode=="ellipse"){
        if(click==0){
            message = "click centerpoint";
        }
        if(click==1){
            object.type="line";
            object.red=0; //todo : connect to gui
            object.green=1;
            object.blue=1;
            object.alpha=1;
            object.start.x=mx;
            object.start.y=my;
            object.start.z=mz;
            object.end.x=mx;
            object.end.y=my;
            object.end.z=mz;
            object.center.x=mx;
            object.center.y=my;
            object.center.z=mz;
            object.pi_angle_start = 0;
            object.pi_angle_end = 2*M_PI;
            click=2;
        }
        if(click==2){
            object.end.x=mx; //preview as line
            object.end.y=my;
            object.end.z=mz;
            message = "click endpoint mayor axis";
        }
        if(click==3){
            object.type="ellipse"; //morph into ellipse
            object.start.x=object.end.x;
            object.start.y=object.end.y;
            object.start.z=object.end.z;

            object.input.x=mx; //ellipse height preview
            object.input.y=my;
            object.input.z=mz;

            message = "click endpoint minor axis";
        }
        if(click==4){
            controlpoints();
            objects.push_back(object); //write data to program
            clear();
        }
        if(int_key==16777216){//key escape, clean preview data
            clear();
        }
    }

    if(mode=="arc"){
        if(click==0){
            message = "click startpoint";
        }
        if(click==1){
            object.type="line";
            object.red=0; //todo : connect to gui
            object.green=1;
            object.blue=1;
            object.alpha=1;
            object.start.x=mx;
            object.start.y=my;
            object.start.z=mz;
            object.end.x=mx;
            object.end.y=my;
            object.end.z=mz;
            click=2;
        }
        if(click==2){ //preview as line
            object.end.x=mx;
            object.end.y=my;
            object.end.z=mz;
        }
        if(click==3){ //morph into arc
            object.type="arc";
            object.control.push_back({object.end.x,object.end.y,object.end.z});
            click=4;
        }
        if(click==4){ //preview arc endpoint
            object.end.x=mx;
            object.end.y=my;
            object.end.z=mz;
        }
        if(click==5){ //write arc
            //calculate arc center
            POINT center = arc_center({object.start.x,object.start.y,object.start.z},{object.control.at(0).x,object.control.at(0).y,object.control.at(0).z},{object.end.x,object.end.y,object.end.z});
            object.center.x=center.x;
            object.center.y=center.y;
            object.center.z=center.z;

            objects.push_back(object);
            clear();
        }

        if(int_key==16777216){//key escape, clean preview data
            clear();
        }
    }

    if(mode=="spline"){
        if(click==0){
            message = "click startpoint";
        }
        if(click==1){
            object.type="line";
            object.red=0; //todo : connect to gui
            object.green=1;
            object.blue=1;
            object.alpha=1;
            object.start.x=mx;
            object.start.y=my;
            object.start.z=mz;
            object.end.x=mx;
            object.end.y=my;
            object.end.z=mz;
            click=2;
        }
        if(click==2){ //preview as line
            object.end.x=mx;
            object.end.y=my;
            object.end.z=mz;
        }
        if(click==3){ //morph into spline
            object.type="spline";
            object.control.push_back({object.end.x,object.end.y,object.end.z});
            click=4;
        }
        if(click==4){ //preview spline endpoint
            object.end.x=mx;
            object.end.y=my;
            object.end.z=mz;
        }

        if(click>4){ //add new controlpoint
            click=3;
        }

        if(int_key==16777216){//key escape, clean preview data
            clear();
        }

        if(int_key==16777220){//key enter
            if(object.control.size()>1){
                object.end.x=object.control.back().x; //finish spline endpoint to last clicked control point
                object.end.y=object.control.back().y;
                object.end.z=object.control.back().z;
                object.control.pop_back(); //remove last control point.
            }

            object.red=0; //todo : connect to gui
            object.green=1;
            object.blue=1;
            object.alpha=1;
            objects.push_back(object); //add spline to program data, clean preview data
            clear();
        }
    }

    if(mode=="bezier"){

        if(click==0){
            message = "click startpoint";
        }
        if(click==1){
            object.type="line";
            object.red=0; //todo : connect to gui
            object.green=1;
            object.blue=1;
            object.alpha=1;
            object.start.x=mx;
            object.start.y=my;
            object.start.z=mz;
            object.end.x=mx;
            object.end.y=my;
            object.end.z=mz;
            click=2;
        }
        if(click==2){ //preview
            object.end.x=mx;
            object.end.y=my;
            object.end.z=mz;
        }
        if(click==3){ //morph into spline
            object.type="spline";
            object.control.push_back({mx,my,mz}); //first control point
            click=4;
        }
        if(click==4){ //preview
            object.end.x=mx;
            object.end.y=my;
            object.end.z=mz;
        }
        if(click==5){
            object.control.push_back({mx,my,mz}); //second control point
            click=6;
        }
        if(click==6){ //preview
            object.type="bezier"; //morph into bezier
            object.end.x=mx;
            object.end.y=my;
            object.end.z=mz;
        }
        if(click==7){
            objects.push_back(object);
            clear();
        }
        if(int_key==16777216){//key escape, clean preview data
            clear();
        }
    }

    if(mode=="polygon"){
        if(click==0){
            message = "click centerpoint";
        }
        if(click==1){
            object.type="polygon";
            object.center.x=mx;
            object.center.y=my;
            object.center.z=mz;
            object.sides=10;
            click=2;
        }
        if(click==2){ //preview
            object.end.x=mx;
            object.end.y=my;
            object.end.z=mz;
        }
        if(click==3){ //write data
            object.type="linestrip"; //morph into linestrip
            objects.push_back(object);
            clear();
        }
        if(int_key==16777216){//key escape, clean preview data
            clear();
        }
    }
}

void clear(){
    object.type="";
    object.red=0;
    object.green=0;
    object.blue=0;
    object.alpha=0;
    object.start.x=0;
    object.start.y=0;
    object.start.z=0;
    object.end.x=0;
    object.end.y=0;
    object.end.z=0;
    object.control.clear();
    click=0;
    int_key=-1; //reset key
}

POINT arc_center(POINT a, POINT b, POINT c){
    POINT center;
    double x1 = (b.x + a.x) / 2;
    double y1 = (b.y + a.y) / 2;
    double dy1 = b.x - a.x;
    double dx1 = -(b.y - a.y);

    //Get the perpendicular bisector of (x2, y2) and (x3, y3).
    double x2 = (c.x + b.x) / 2;
    double y2 = (c.y + b.y) / 2;
    double dy2 = c.x - b.x;
    double dx2 = -(c.y - b.y);

    double endpoint_x0 = x1 + dx1;
    double endpoint_y0 = y1 + dy1;
    double endpoint_x1 = x2 + dx2;
    double endpoint_y1 = y2 + dy2;

    //line 1
    double delta_y0 = endpoint_y0 - y1;
    double delta_x0 = x1 - endpoint_x0;
    double c0 = delta_y0 * x1 + delta_x0 * y1;
    //line 2
    double delta_y1 = endpoint_y1 - y2;
    double delta_x1 = x2 - endpoint_x1;
    double c1 = delta_y1 * x2 + delta_x1 * y2;

    double determinant = delta_y0*delta_x1 - delta_y1*delta_x0;
    double deg_start_angle=0;
    double deg_end_angle=0;
    double radius=0;
    double x_center=0;
    double y_center=0;

    if (determinant==0){
        // lines are parallel
    } else {
        center.x = (delta_x1*c0 - delta_x0*c1)/determinant;
        center.y = (delta_y0*c1 - delta_y1*c0)/determinant;
    }
    return center;
}






























